class RpcParameterKeys:
    """
    RPC clients pass in configuration options for pubs / subs using a Map < String, Object >.
    The keys of the map are defined here.

    I actually copied the same identifiers as in RuntimeProperties.java
    wherever the equivalent one already existed, for familiarity.
    """
    # CustomConfigure (CLIENT)
    CLIENT_COUNT = "client-count"
    PUBS_PER_SESSION = "pubs-per-session"
    CLIENT_VPN = "vpn"
    DEMUX = "demux"
    CLIENT_NAME = "client-name"
    CLIENT_NAME_PREFIX = "client-name-prefix"
    CLIENT_DESCRIPTION = "description"
    AD_PUB_ACKTIME = "ad-pub-ack-time"
    AD_PUB_WINDOW = "ad-pub-win-size"
    PUB_MAX_RESENDS = "pub-max-resends"
    WANT_SMOOTH_PUB = "smooth-high-cpu"
    PSM_CALC_LAT = "psm-calc-lat"
    READ_TIMEOUT = "read-timeout"
    AD_SUB_ACKTIME = "ad-sub-acktime"
    AD_SUB_WINDOW = "ad-sub-window"
    AD_WIN_THRESH = "ad-sub-thresh"
    SUB_LATENCY_BUCKETS = "sub-latency-buckets"
    SUB_LATENCY_GRANULARITY = "sub-latency-granularity"
    SUB_LATENCY_WARMUP = "sub-latency-warmup"
    SUB_SLOW_DELAY_MILLIS = "sub-slow-delay-in-millis"
    SUB_SLOW_DELAY_COUNT = "sub-slow-delay-count"
    SUB_WANT_PERCID_STATS = "want-cid-stats"
    SUB_WANT_FULL_INSPECTION = "want-full-msg-stats"
    SUBSCRIBER_RATE_INTERVAL = "subscriber-rate-interval"
    CLIENT_DTO_LOCAL_PRI = "dto-local-pri"
    CLIENT_DTO_NETWORK_PRI = "dto-network-pri"
    CLIENT_COMPRESSION_LEVEL = "compression-level"
    PAYLOAD_COMPRESSION_LEVEL = "payload-compression-level"
    CHANGE_CLIENT_NAME = "change-client-name"
    CLIENT_CLASS = "client-class"
    WANT_DI_STATS = "di"
    WANT_USER_PROP_TOOL_DATA = "prop-tool-data"
    WANT_NON_BLOCKING_CONNECT = "non-blocking-connect"
    WANT_PER_MESSAGE_DETAILS = "want-per-message-details"
    LAST_MESSAGES_QUEUE_DEPTH = "last-messages-queue-depth"
    REST_SERVER_RESPONSE_OVERRIDE = "rest-server-response-override"
    REST_SERVER_RESPONSE_CONTENT = "rest-server-response-content"
    REST_SERVER_RESPONSE_CONTENT_FILE = "rest-server-response-content-file"
    REST_SERVER_AUTH_USERNAME = "rest-server-authorization-username"
    REST_SERVER_AUTH_PASSWORD = "rest-server-authorization-password"
    REST_SERVER_AUTH_HTTP_HEADER_NAME = "rest-server-auth-http-header-name"
    REST_SERVER_AUTH_HTTP_HEADER_VALUE = "rest-server-auth-http-header-value"
    REST_SERVER_NUM_THREADS = "rest-server-num-threads"

    WANT_MESSAGE_PRIORITY_STATS = "want-message-priority-stats"
    REQUEST_REPLY_WAIT_TIME = "request-reply-wait-time"

    CACHE_PROP_NAME = "cache-prop-name"
    CACHE_PROP_MAX_MSGS_PER_TOPIC = "cache-prop-max-msgs"
    CACHE_PROP_MAX_AGE = "cache-prop-max-age"
    CACHE_PROP_TIMEOUT_IN_MSEC = "cache-prop-timeout"
    SUB_MSG_QUEUE_DEPTH = "msg-queue-depth"
    JNDI_FOR_JMS = "jndi-for-jms"
    REAPPLY_SUBSCRIPTIONS = "reapply-subscriptions"
    IGNORE_EXISTS_ERRORS = "ignore-exists"
    NO_LOCAL = "no-local"
    SESSION_NAME = "session-name"
    TRANSACTION_SIZE = "transaction-size"
    TRANSACTION_IDLE_TIME = "transaction-idle-time"
    TRANSACTION_ROLLBACK_INTERVAL = "transaction-rollback-interval"
    WANT_XA = "want-xa"
    XA_WANT_ONE_PHASE_COMMIT_TRANSACTION = "xa-want-one-phase-commit-transaction"
    XA_NUM_MSGS_PER_TRANSACTION_SEGMENT = "xa-num-msgs-per-transaction-segment"
    XA_NUM_SUSPENDED_TRANSACTIONS = "xa-num-suspended-transactions"
    WANT_CLIENT_ACK = "want-client-ack"
    WANT_CLIENT_ACK_THREAD = "want-client-ack-thread"
    CLIENT_ACK_SKIP_NUM = "client-ack-skip-num"
    CLIENT_ACK_QUEUE_DEPTH = "client-ack-queue-depth"
    CLIENT_ACK_QUEUE_FLUSH = "client-ack-queue-flush"
    CLIENT_ACK_QUEUE_REVERSE = "client-ack-queue-reverse"
    CLIENT_ACK_RANDOM_DEPTH = "client-ack-random-depth"
    SETTLEMENT_PATTERN_STRING = "settlement-pattern-string"
    REQUIRED_SETTLEMENTS_STRING = "required-settlements-string"
    AD_ACK_EVENT_MODE = "ad-ack-event-mode"
    CUSTOM_PROPERTY_LIST = "custom-property-list"
    WANT_REPLY_TO_TOPIC = "want-reply-to"
    WANT_REPLY_TO_POSTFIX = "reply-to-postfix"
    WANT_REPLY_TO_STRING = "reply-to-string"
    WANT_REPLY_TO_TEMPORARY_QUEUE = "want-reply-to-temp-queue"
    CLIENT_MODE = "client-mode"
    CLIENT_PASSWORD_FILE = "client-password-file"

    NUM_MESSAGE_PRODUCERS = "num-message-producers"
    RECEIVER_BACKPRESSURE_TYPE = "receiver-backpressure-type"
    RECEIVER_BACKPRESSURE_BUFFER = "receiver-backpressure-buffer"
    RECEIVER_SLEEP_TIME = 'receiver-sleep-time'
    DISABLE_TERMINATION_LISTENERS = 'disable-termination-listeners'
    WANT_UNGRACEFUL_TERMINATE = 'want-ungraceful-terminate'
    WANT_UNGRACEFUL_DISCONNECT = 'want-ungraceful-disconnect'

    # StartPublishing (PUB)
    DOC_FILE_ARRAY = "doc-file-array"
    ATTACHMENT_FILE_ARRAY = "attachment-file-array"
    TOPICS_ARRAY = "topics-array"
    TOPICS_FILE = "topics-file"
    QUEUES_FILE = "queues-file"
    MSG_TYPE = "msg-type"
    MESSAGE_OBJECT_TYPE = "message-object-type"
    MESSAGE_OBJECT_TYPE_CHECK = "message-object-type-check"
    WANT_RESPONSE_CHECK = "want-response-check"
    WANT_UD = "want-ud"
    WANT_STOP_ON_ERROR = "want-stop-on-error"
    XML_PAYLOAD_SIZE = "xml-payload-size"
    ATTACHMENT_SIZE = "attachment-size"
    XML_PAYLOAD_SIZE_LIST = "xml-payload-size-list"
    ATTACHMENT_SIZE_LIST = "attachment-size-list"
    ATTACHMENT_SIZE_SWEEP = "attachment-size-sweep"
    USER_COS = "cos"
    WANT_DTO = "want-dto"
    BURST_DURATION = "burst-duration"
    INTER_BURST_DURATION = "inter-burst-duration"
    PUB_SEND_VECT = "send-vect-size"
    TTL = "ttl"
    DMQ_ELIGIBLE = "dmqe"
    ELIDING = "eliding"
    PUB_STREAM_OFFSET = "stream-id-offset"
    PUB_ORDER_OFFSET = "order-offset"
    XA_SESSION_NAMES_ARRAY = "session-names-array"
    DISCARD_NOTIFY_SENDER = "discard-notify-sender"
    ACK_IMMEDIATELY_INTERVAL = "ack-immediately-interval"
    WANT_PUB_ACK_ORDER_CHECK = "want-pub-ack-order-check"
    WANT_REPLICATION_RECONNECT = "want-replication-reconnect"
    RECONNECT_FAIL_ACTION = "reconnect-fail-action"
    WANT_CUT_THROUGH_PERSISTENCE = "want-cut-through-persistence"
    SKIP_FINAL_COMMIT = "skip-final-commit"
    CORRELATION_ID = "correlation-id"
    MESSAGE_ID = "message-id"
    PUBLISH_MESSAGE_PRIORITY_LIST = "publish-message-priority-list"
    MESSAGE_PRIORITY = "message-priority"
    WANT_MSG_PRIORITY_ORDER_CHECKING = "want-msg-priority-order-checking"
    WANT_REPLAY = "want-replay"
    WANT_REPLAY_FROM_DATE = "want-replay-from-date"
    WANT_REPLAY_FROM_MSG_ID = "want-replay-from-msg-id"
    RECONNECT_TRIES = "reconnect-tries"
    RECONNECT_RETRY_INTERVAL_IN_MSECS = "reconnect-retry-interval-in-msecs"
    PUBLISHER_BACKPRESSURE_TYPE = "publisher-backpressure-type"
    PUBLISHER_BACKPRESSURE_BUFFER = "publisher-backpressure-buffer"
    PARTITION_KEY_LIST = "partition-key-list"

    # Queue Browsing
    SELECTOR = "selector"
    DELETE_FREQUENCY = "del-freq"
    DELETE_BUFFER = "del-buf"

    # Publish On Receive
    PUB_ON_RCV_NUMBER_OF_MESSAGES = "pub-on-rcv-number-of-messages"
    PUB_ON_RCV_TOPIC_LIST = "pub-on-rcv-topic-list"
    PUB_ON_RCV_QUEUE_LIST = "pub-on-rcv-queue-list"
    PUB_ON_RCV_MESSAGE_TYPE = "pub-on-rcv-message-type"
    PUB_ON_RCV_ATTACHMENT_SIZE_LIST = "pub-on-rcv-attachment-size-list"
    PUB_ON_RCV_REFLECT_MESSAGE = "pub-on-rcv-reflect-message"

    # Shared
    QUEUES_ARRAY = "queues-array"
    WANT_LATENCY = "want-latency"
    WANT_PAYLOAD_CHECK = "want-payload-check"
    WANT_ORDER_CHECK = "want-order-check"
    WANT_ORDER_MEMORY = "want-order-memory"
    TCP_NO_DELAY = "tcp-no-delay"
    API_MODE = "api-mode"
    CLIENT_WANT_AUTO_GEN_SDM = "want-auto-gen-sdm"
    SDM_FILE_ARRAY = "sdm-file-array"
    SDM_STRINGS_ARRAY = "sdm-strings-array"
    CLIENT_WANT_STRUCT_MSG_CHECK = "want-struct-msg-check"

    MSG_NUM = "msg-num"
    MSG_RATE = "msg-rate"
    MSG_RATE_IS_MAX = "msg-rate-is-max"

    EP_LIST = "endpoints"
    IS_ADDING = "is-add"
    ACCESS_TYPE = "access-type"
    MAX_MSG_SIZE = "max-msg-size"
    MAX_MSG_REDELIVERY = "max-msg-redelivery"
    QUOTA = "quota"
    PERMISSION = "permission"
    CLIENT_IDX = "client"
    SUBSCRIPTIONS = "subscriptions"
    SUBSCRIPTIONS_FILE = "subs-file"
    SELECTORS = "selectors"
    IS_TOPIC_ENDPOINT = "is-te"
    NUM_END_POINTS = "num-eps"
    RESPECT_TTL = "respect-ttl"
    SUBSCRIPTION_DEST_TYPE = "sub-dest-type"
    UNSUBSCRIBE = "unsubscribe"
    STREAM_OFFSET = "stream-id"
    ACTIVE_FLOW_IND = "active-flow-ind"
    ENDPOINT_NAME = "ep-name"
    ENDPOINT_TYPE = "ep-type"
    SKIP_ENDPOINT_NAMES = "skip-endpoint-names"

    TOPIC_PREFIX = "topic-prefix"
    TOPIC_COUNT = "topic-count"
    DISTRIBUTE_TOPICS = "distribute-topics"

    CACHE_REQ_LIVE_DATA_ACTION = "live-data-action"
    CACHE_REQ_MIN_SEQ = "min-seq"
    CACHE_REQ_MAX_SEQ = "max-seq"
    CACHE_REQ_WANT_SUBSCRIBE = "want-subscribe"
    CACHE_REQ_WAIT_FOR_CONFIRM = "wait-confirm"

    # SSL (Deprecated)
    SSL_PROTOCOL = "ssl-protocol"
    SSL_CONNECTION_DOWNGRADE_TO = "ssl-connection-downgrade-to"
    SSL_EXCLUDED_PROTOCOL = "ssl-excluded-protocols"
    SSL_VALIDATE_CERTIFICATE = "ssl-validate-certificate"
    SSL_VALIDATE_CERTIFICATE_DATE = "ssl-validate-certificate-date"
    SSL_VALIDATE_CERTIFICATE_HOSTNAME = "ssl-validate-certificate-hostname"
    SSL_CIPHER_SUITES = "ssl-cipher-suites"
    SSL_TRUST_STORE = "ssl-trust-store"
    SSL_TRUST_STORE_DIR = "ssl-trust-store-dir"
    SSL_TRUST_STORE_PASSWORD = "ssl-trust-store-password"
    SSL_TRUST_STORE_FORMAT = "ssl-trust-store-format"
    SSL_TRUSTED_COMMON_NAME_LIST = "ssl-trusted-common-name-list"
    SSL_KEY_STORE = "ssl-key-store"
    SSL_KEY_STORE_PASSWORD = "ssl-key-store-password"
    SSL_KEY_STORE_FORMAT = "ssl-key-store-format"
    SSL_PRIVATE_KEY_ALIAS = "ssl-private-key-alias"
    SSL_PRIVATE_KEY_PASSWORD = "ssl-private-key-password"
    # SSL (ccsmp / jni)
    SSL_CLIENT_PRIVATE_KEY_FILE = "ssl-client-private-key-file"
    SSL_CLIENT_PRIVATE_KEY_FILE_PASSWORD = "ssl-client-private-key-file-password"
    SSL_CLIENT_CERTIFICATE_FILE = "ssl-client-certificate-file"

    AUTHENTICATION_SCHEME = "authentication-scheme"
    OAUTH_ACCESS_TOKEN = "oauth-access-token"
    OAUTH_ISSUER_ID = "oauth-issuer-id"
    OAUTH_ID_TOKEN = "oidc-id-token"

    # Extra Parameter List
    EXTRA_PARAMETER_LIST = "extra-props-array"

    # HTTP
    HTTP_CONTENT_TYPE = "http-content-type"
    HTTP_CONTENT_ENCODING = "http-content-encoding"

    # Tracing Options
    WANT_TRACE_CREATION_CONTEXT = "want-trace-creation-context"
    WANT_TRACE_TRANSPORT_CONTEXT = "want-trace-transport-context"
    BAGGAGE = "baggage"
    TRACE_EXPORTER_CONNECTION_STRING = "trace-exporter-connection-string"
    TRACE_COPY_RECEIVE_CONTEXT = "trace-copy-receive-context"
