from enum import Enum


class AuthenticationScheme(Enum):
    BASIC = 1
    CLIENT_CERTIFICATE = 2
    GSS_KRB = 3
    OAUTH2 = 4

    @classmethod
    def default(cls):
        return cls.BASIC

    @classmethod
    def get_name(cls, value):
        if value == cls.BASIC:
            return "BASIC"
        elif value == cls.CLIENT_CERTIFICATE:
            return "CLIENT-CERTIFICATE"
        elif value == cls.GSS_KRB:
            return "KERBEROS"
        elif value == cls.OAUTH2:
            return "OAUTH2"
        else:
            raise Exception("UNKNOWN AUTHENTICATION SCHEME ENUM NAME")
