from abc import abstractmethod, ABC


class AbstractWrappedMessage(ABC):
    @abstractmethod
    def get_message(self):
        pass

    @abstractmethod
    def has_xml(self):
        pass

    @abstractmethod
    def has_attachment(self):
        pass

    @abstractmethod
    def has_topic(self):
        pass

    @abstractmethod
    def get_destination_name(self):
        pass

    @abstractmethod
    def get_destination_type(self):
        pass

    @abstractmethod
    def get_delivery_mode(self):
        pass

    @abstractmethod
    def get_xml_bytes(self):
        pass

    @abstractmethod
    def get_attachment_bytes(self):
        pass

    @abstractmethod
    def dump(self):
        pass

    @abstractmethod
    def get_message_as_bytes(self):
        pass

    @abstractmethod
    def get_discard_indication(self):
        pass

    @abstractmethod
    def get_priority(self):
        pass
