from pypubsubtools.core.runtime_properties import RuntimeProperties
from sdkperf.core.python_client import PythonClient


class ClientFactory:
    def __init__(self):
        pass

    @staticmethod
    def create_client(props: RuntimeProperties, client_id: int, cc: 'AbstractClientCollection'):
        client = PythonClient()
        client.set_collection(cc)
        client.init(props, client_id)

        return client

    @staticmethod
    def generate_client_id_str(props: RuntimeProperties, client_id: int):
        client_id_str = ""

        if hasattr(props, RuntimeProperties.CLIENT_NAME_PREFIX):
            client_id_str += getattr(props, RuntimeProperties.CLIENT_NAME_PREFIX)
        else:
            client_id_str += "pubsub_client"

        client_id_str = f"{client_id_str}{client_id:06}"

        return client_id_str
