import random


class MessagePriorityGenerator:
    def __init__(self, msg_priorities_int):
        self.msg_priorities_list = list()
        # msg_priorities_int is of the format <pri>,<weight>,...
        for pri, weight in self._grouped(msg_priorities_int, 2):
            for x in range(weight):
                self.msg_priorities_list.append(pri)

    def get_random_priority(self):
        rnd = random.randrange(0, len(self.msg_priorities_list))
        return self.msg_priorities_list[rnd]

    @staticmethod
    def _grouped(iterable, n):
        """
        This helper method returns an iterator that has pairs of values
        so from the list: 0,10,2,10,3,10,4,10,5,10,6,10,7,10,8,10,9,10
        it would return (0,10),(2,10),etc...
        """
        return zip(*[iter(iterable)] * n)
