class SingleStreamOrderCheckingData:

    def __init__(self, lost_msg_ids=None, dup_msg_ids=None, redelivered_dup_msg_ids=None, republished_dup_msg_ids=None,
                 ooo_msg_ids=None, prev_msg_id=None, prev_committed_msg_id=None):
        # Default to an empty object but also can be used as a copy constructor (Using [:] slice forces a copy)
        self.lost_msg_ids = lost_msg_ids[:] if lost_msg_ids is not None else list()
        self.dup_msg_ids = dup_msg_ids[:] if dup_msg_ids is not None else list()
        self.redelivered_dup_msg_ids = redelivered_dup_msg_ids[:] if redelivered_dup_msg_ids is not None else list()
        self.republished_dup_msg_ids = republished_dup_msg_ids[:] if republished_dup_msg_ids is not None else list()
        self.ooo_msg_ids = ooo_msg_ids.copy() if ooo_msg_ids is not None else dict()
        self.prev_msg_id = prev_msg_id if prev_msg_id is not None else -1
        self.prev_committed_msg_id = prev_committed_msg_id if prev_committed_msg_id is not None else self.prev_msg_id

    def aggregate(self, input_obj: "SingleStreamOrderCheckingData"):
        self.lost_msg_ids = self.lost_msg_ids + input_obj.lost_msg_ids
        self.dup_msg_ids = self.dup_msg_ids + input_obj.dup_msg_ids
        self.redelivered_dup_msg_ids = self.redelivered_dup_msg_ids + input_obj.redelivered_dup_msg_ids
        self.republished_dup_msg_ids = self.republished_dup_msg_ids + input_obj.republished_dup_msg_ids
        self.ooo_msg_ids.update(input_obj.ooo_msg_ids)


